<template>
    <div>
        <div class="d-flex justify-content-between">
            <div>
                <h1 class="h3 mb-4 text-gray-800">Item</h1>
            </div>
            <div>
                <router-link
                    :to="{ name: 'ItemCreate' }"
                    class="btn btn-success"
                    role="button"
                    >Create Item</router-link
                >
            </div>
        </div>

        <div class="row">
            <div class="col-12">
                <search-box
                    @input="getObjects"
                    delay="500"
                    ref="searchBox"
                ></search-box>
            </div>
        </div>

        <item-card
            v-for="object in dataObjects"
            :key="object.id * 123"
            :object="object"
            @delete="onDeleted"
        >
        </item-card>

        <div v-if="dataObjects.length == 0" class="card text-black shadow">
            <div class="card-body">
                No Item List
                <div class="text-black-50 small">
                    please create new item
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import SearchBox from "../../components/SearchBoxComponent";
import ItemCard from "../../components/item/ItemCardComponent";
export default {
    components: {
        SearchBox,
        ItemCard
    },
    data() {
        return {
            dataObjects: []
        };
    },
    created() {
        this.prepare();
    },
    mounted() {
        this.$refs.searchBox.$refs.searchBox.focus();
    },
    methods: {
        prepare() {
            this.getObjects();
        },
        getObjects(search = "") {
            axios
                .get("/api/item/all", {
                    params: {
                        limit: 10,
                        tag: this.$route.params.tag,
                        search: search
                    }
                })
                .then(res => {
                    this.dataObjects = res.data;
                })
                .catch(err => {
                    console.log(err.message);
                });
        },
        onDeleted() {
            this.$refs.searchBox.$refs.searchBox.focus();
            this.getObjects();
        }
    }
};
</script>
